Loading...
Searching...
No Matches
mdds::mtv::element_block< Self, TypeId, ValueT, StoreT > Class Template Reference
Inheritance diagram for mdds::mtv::element_block< Self, TypeId, ValueT, StoreT >:

## Public Types

using | store_type = StoreT<ValueT, std::allocator<ValueT>>
typedef store_type::iterator | iterator
typedef store_type::reverse_iterator | reverse_iterator
typedef store_type::const_iterator | const_iterator
typedef store_type::const_reverse_iterator | const_reverse_iterator
typedef ValueT | value_type
using | range_type = base_range_type<true>
using | const_range_type = base_range_type<false>

## Public Member Functions

const store_type & | store () const noexcept
store_type & | store () noexcept
bool | operator== (const Self &r) const noexcept(nothrow_eq_comparable_v)
bool | operator!= (const Self &r) const noexcept(nothrow_eq_comparable_v)

## Static Public Member Functions

static const value_type & | at (const base_element_block &block, typename store_type::size_type pos)
static value_type & | at (base_element_block &block, typename store_type::size_type pos)
static value_type * | data (base_element_block &block)
static store_type::size_type | size (const base_element_block &block)
static iterator | begin (base_element_block &block)
static iterator | end (base_element_block &block)
static const_iterator | begin (const base_element_block &block)
static const_iterator | end (const base_element_block &block)
static const_iterator | cbegin (const base_element_block &block)
static const_iterator | cend (const base_element_block &block)
static reverse_iterator | rbegin (base_element_block &block)
static reverse_iterator | rend (base_element_block &block)
static const_reverse_iterator | rbegin (const base_element_block &block)
static const_reverse_iterator | rend (const base_element_block &block)
static const_reverse_iterator | crbegin (const base_element_block &block)
static const_reverse_iterator | crend (const base_element_block &block)
static const_range_type | range (const base_element_block &block)
static range_type | range (base_element_block &block)
static Self & | get (base_element_block &block)
static const Self & | get (const base_element_block &block)
static void | set_value (base_element_block &blk, size_t pos, const ValueT &val)
static void | get_value (const base_element_block &blk, size_t pos, ValueT &val)
static value_type | get_value (const base_element_block &blk, size_t pos)
template<typename T = ValueT>
static void | append_value (base_element_block &blk, T &&val)
template<typename... Args>
static void | emplace_back_value (base_element_block &blk, Args &&... args)
static void | prepend_value (base_element_block &blk, const ValueT &val)
static Self * | create_block (size_t init_size)
static void | delete_block (const base_element_block *p)
static void | resize_block (base_element_block &blk, size_t new_size)
static void | print_block (const base_element_block &)
static void | erase_value (base_element_block &blk, size_t pos)
static void | erase_values (base_element_block &blk, size_t pos, size_t size)
static void | append_block (base_element_block &dest, const base_element_block &src)
static void | append_values_from_block (base_element_block &dest, const base_element_block &src, size_t begin_pos, size_t len)
static void | assign_values_from_block (base_element_block &dest, const base_element_block &src, size_t begin_pos, size_t len)
static void | prepend_values_from_block (base_element_block &dest, const base_element_block &src, size_t begin_pos, size_t len)
static void | swap_values (base_element_block &blk1, base_element_block &blk2, size_t pos1, size_t pos2, size_t len)
static bool | equal_block (const base_element_block &left, const base_element_block &right)
template<typename Iter>
static void | set_values (base_element_block &block, size_t pos, const Iter &it_begin, const Iter &it_end)
template<typename Iter>
static void | append_values (base_element_block &block, const Iter &it_begin, const Iter &it_end)
template<typename Iter>
static void | prepend_values (base_element_block &block, const Iter &it_begin, const Iter &it_end)
template<typename Iter>
static void | assign_values (base_element_block &dest, const Iter &it_begin, const Iter &it_end)
template<typename Iter>
static void | insert_values (base_element_block &block, size_t pos, const Iter &it_begin, const Iter &it_end)
static size_t | capacity (const base_element_block &block)
static void | reserve (base_element_block &block, std::size_t size)
static void | shrink_to_fit (base_element_block &block)

## Static Public Attributes

static constexpr element_t | block_type = TypeId

## Protected Member Functions

| element_block (size_t n)
| element_block (size_t n, const ValueT &val)
template<typename Iter>
| element_block (const Iter &it_begin, const Iter &it_end)
Protected Member Functions inherited from mdds::mtv::base_element_block
| base_element_block (element_t _t) noexcept

## Protected Attributes

store_type | m_array
Protected Attributes inherited from mdds::mtv::base_element_block
element_t | type